Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.cc	(revision 4139)
@@ -33,14 +33,44 @@
 GuiKeys::GuiKeys(void)
 {
-  this->keysFrame = new Frame("Keyboard-Options:");
-  //  keysFrame->setGroupName("Keyboard");
-  this->keysBox = new Box('h');
-  this->player1 = new Player("player1");
-  this->player2 = new Player("player2");
-
-  this->keysBox->fill(this->player1->getOpenButton());
-  this->keysBox->fill(this->player2->getOpenButton());
-
-  this->keysFrame->fill(this->keysBox);
+  Frame* keysFrame;      //!< The Frame that holds the keyOptions.
+
+  keysFrame = new Frame("Keyboard-Options:");
+  {
+    Box* keysBox0;          //!< The Frame that holds the keyOptions.
+    
+    //  keysFrame->setGroupName("Keyboard");
+    keysBox0 = new Box('v');
+    {
+      Box* keysBox1;
+      MiscKeys* misc;            //!< The Misc Keys
+
+      keysBox1 = new Box('h');
+      {
+	PlayerKeys* player1;       //!< The first Player's keys.
+	PlayerKeys* player2;       //!< The seconds Player's keys.
+	
+	player1 = new PlayerKeys(CONFIG_SECTION_PLAYER "1");
+	player2 = new PlayerKeys(CONFIG_SECTION_PLAYER "2");
+	
+	keysBox1->fill(player1->getOpenButton());
+	keysBox1->fill(player2->getOpenButton());
+      }
+      keysBox0->fill(keysBox1);
+
+      misc = new MiscKeys();
+      keysBox0->fill(misc->getOpenButton());
+    }
+    keysFrame->fill(keysBox0);
+  }
+  
+  // setting up the Input Windows that receives keystrokes.
+  this->inputWindow = new Window("inputWindow");
+  this->inputButton = new Button("test");
+#ifdef HAVE_GTK2
+  this->inputWindow->connectSignal("destroy",  Widget::doNothingSignal);
+  this->inputWindow->connectSignal("delete_event", Widget::doNothingSignal);
+#endif /* HAVE_GTK2 */
+  this->inputWindow->fill(inputButton);
+  
   this->setMainWidget(keysFrame);
 }
@@ -54,54 +84,139 @@
 }
 
+
+Window* GuiKeys::inputWindow = NULL;
+Button* GuiKeys::inputButton = NULL;
+long GuiKeys::keySignal = 0;
+
+////////////
 /* PLAYER */
-
+////////////
 /**
    \brief Creates new inputs for a player
    \param player the name of the Player
 */
-Player::Player(char* player)
-{
-  char* windowName = new char[strlen(player)+25];
-  strcpy(windowName, "Keyboard settings of ");
+PlayerKeys::PlayerKeys(char* player)
+{
+  Window* pKeyWindow;     //!< The Window for a new Key-setting.
+
+  char* windowName = new char[strlen(player)+12];
+  strcpy(windowName, "KeySets: ");
   strcat(windowName, player);
-  this->pKeyWindow = new Window(windowName);
-  this->pKeyFrame = new Frame(windowName);
-   this->pKeysBox = new Box('v');
-   this->pKeysBox->setGroupName(player);
-    this->pKeysBox->fill(addKey(UP, "up"));
-    this->pKeysBox->fill(addKey(DOWN, "down"));
-    this->pKeysBox->fill(addKey(LEFT, "left"));
-    this->pKeysBox->fill(addKey(RIGHT, "right"));
-    this->pKeysBox->fill(addKey(SHOOT, "shoot"));
-    delete windowName;
-    closeButton = new Button("close");
-#ifdef HAVE_GTK2
-    this->closeButton->connectSignal("button_press_event", this->pKeyWindow, Window::windowClose);
-#endif /* HAVE_GTK2 */
-
-    this->pKeysBox->fill(this->closeButton);
-    this->pKeyFrame->fill(this->pKeysBox);
-   this->pKeyWindow->fill(this->pKeyFrame);
-   Window::addWindow(this->pKeyWindow);
-#ifdef HAVE_GTK2
-   this->pKeyWindow->connectSignal("destroy", this->pKeyWindow, Window::windowClose);
-   this->pKeyWindow->connectSignal("delete_event", this->pKeyWindow, Window::windowClose);
-#endif /* HAVE_GTK2 */
-
+  pKeyWindow = new Window(windowName);
+  {
+    Frame* pKeyFrame;       //!< The Frame for a new Key-setting.
+
+    pKeyFrame = new Frame(windowName);
+    {
+      Box* pKeysBox;          //!< The Box that holds the Key-settings.
+      pKeysBox = new Box('v');
+      {
+	Button* closeButton;    //!< The CloseButton for this key-settings.
+
+	pKeysBox->setGroupName(player);
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_UP, "UP"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_DOWN, "DOWN"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_LEFT, "LEFT"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_RIGHT, "RIGHT"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_FIRE, "SPACE"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_NEXT_WEAPON, "m"));
+	pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_PREV_WEAPON, "n"));
+	closeButton = new Button("close");
+#ifdef HAVE_GTK2
+	closeButton->connectSignal("button_press_event", pKeyWindow, Window::windowClose);
+#endif /* HAVE_GTK2 */
+
+	pKeysBox->fill(closeButton);
+      }
+      pKeyFrame->fill(pKeysBox);
+    }
+    pKeyWindow->fill(pKeyFrame);
+  }
+  delete windowName;
+  Window::addWindow(pKeyWindow);
+#ifdef HAVE_GTK2
+  pKeyWindow->connectSignal("destroy", pKeyWindow, Window::windowClose);
+  pKeyWindow->connectSignal("delete_event", pKeyWindow, Window::windowClose);
+#endif /* HAVE_GTK2 */
+  
   this->openButton = new Button(player);
 #ifdef HAVE_GTK2
-  this->openButton->connectSignal("button_press_event", this->pKeyWindow, Window::windowOpen);
-#endif /* HAVE_GTK2 */
-
-  this->inputWindow = new Window("inputWindow");
-
-  this->inputButton = new Button("test");
-  this->inputWindow->fill(inputButton);
-#ifdef HAVE_GTK2
-  this->inputWindow->connectSignal("destroy",  Widget::doNothingSignal);
-  this->inputWindow->connectSignal("delete_event", Widget::doNothingSignal);
-#endif /* HAVE_GTK2 */
-
-}
+  this->openButton->connectSignal("button_press_event", pKeyWindow, Window::windowOpen);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \returns the OpenButton of a Player
+*/
+Button* PlayerKeys::getOpenButton(void)
+{
+  return this->openButton;
+}
+
+//////////////////
+/* MISC_OPTIONS */
+//////////////////
+/**
+   \brief Creates new inputs for a misc
+   \param player the name of the Misc
+*/
+MiscKeys::MiscKeys()
+{
+  Window* keyWindow;     //!< The Window for a new Key-setting.
+
+  keyWindow = new Window("misc Keys");
+  {
+    Frame* keyFrame;       //!< The Frame for a new Key-setting.
+
+    keyFrame = new Frame("misc Keys:");
+    {
+      Box* keysBox;          //!< The Box that holds the Key-settings.
+      keysBox = new Box('v');
+      {
+	Button* closeButton;    //!< The CloseButton for this key-settings.
+
+	keysBox->setGroupName(CONFIG_SECTION_MISC_KEYS);
+	keysBox->fill(addKey(CONFIG_NAME_QUIT , "ESCAPE"));
+	keysBox->fill(addKey(CONFIG_NAME_PAUSE, "PAUSE"));
+	keysBox->fill(addKey(CONFIG_NAME_NEXT_WORLD, "x"));
+	keysBox->fill(addKey(CONFIG_NAME_PREV_WORLD, "z"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW0, "1"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW1, "2"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW2, "3"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW3, "4"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW4, "5"));
+	keysBox->fill(addKey(CONFIG_NAME_VIEW5, "6"));
+
+	closeButton = new Button("close");
+#ifdef HAVE_GTK2
+	closeButton->connectSignal("button_press_event", keyWindow, Window::windowClose);
+#endif /* HAVE_GTK2 */
+
+	keysBox->fill(closeButton);
+      }
+      keyFrame->fill(keysBox);
+    }
+    keyWindow->fill(keyFrame);
+  }
+  Window::addWindow(keyWindow);
+#ifdef HAVE_GTK2
+  keyWindow->connectSignal("destroy", keyWindow, Window::windowClose);
+  keyWindow->connectSignal("delete_event", keyWindow, Window::windowClose);
+#endif /* HAVE_GTK2 */
+  
+  this->openButton = new Button("misc");
+#ifdef HAVE_GTK2
+  this->openButton->connectSignal("button_press_event", keyWindow, Window::windowOpen);
+#endif /* HAVE_GTK2 */
+}
+
+/**
+   \returns the OpenButton of a Misc
+*/
+Button* MiscKeys::getOpenButton(void)
+{
+  return this->openButton;
+}
+
 
 /**
@@ -111,48 +226,31 @@
    \returns A widget that has the Key-Box
 */
-Widget* Player::addKey(KEYS key, char* name)
-{
-  this->inputKey[key] = new InputKey;
-  this->inputKey[key]->pKeyBox = new Box();
-  this->inputKey[key]->pKeyButton = new Button(name);
-  this->inputKey[key]->pKeyOLabel = new OptionLabel(name, name);
-  this->inputKey[key]->pKeyOLabel->saveability();
-
-#ifdef HAVE_GTK2
-  //inputKey[key]->pKeyButton->connectSignal("key_press_event", inputKey[key]->pKeyButton, key_cb);
-  this->inputKey[key]->pKeyButton->connectSignal("button_press_event", this->inputKey[key], inputWindowEvent);
-#endif /* HAVE_GTK2 */
-  this->inputKey[key]->pKeyBox->fill(this->inputKey[key]->pKeyButton);
-  this->inputKey[key]->pKeyBox->fill(this->inputKey[key]->pKeyOLabel);
-  return this->inputKey[key]->pKeyBox;
-}
-
-/**
-   \returns the OpenButton of a Player
-*/
-Button* Player::getOpenButton(void)
-{
-  return this->openButton;
-}
-
-/**
-   \brief sets a new Key(only output)
-   \param key the new Key.
-*/
-void Player::setkey(KEYS key)
-{
-  PRINT(4)("setting up Key: %d\n", key);
-}
-
-Window* Player::inputWindow = NULL;
-Button* Player::inputButton = NULL;
-long Player::keySignal = 0;
-
-#ifdef HAVE_GTK2
-gint Player::inputWindowEvent(GtkWidget* w, GdkEventKey* event, void* inputKey)
-{
-  inputButton->setTitle("press a Key");
-  keySignal = inputButton->connectSignal("key_press_event", inputKey, key_cb);
-  inputWindow->open();
+Widget* addKey(const char* name, const char* defaultVal)
+{
+  InputKey* inputKey = new InputKey;
+  inputKey->keyBox = new Box();
+  inputKey->keyButton = new Button(name);
+  if (defaultVal)
+    inputKey->keyOLabel = new OptionLabel(name, defaultVal);
+  else
+    inputKey->keyOLabel = new OptionLabel(name, name);
+  inputKey->keyOLabel->saveability();
+
+#ifdef HAVE_GTK2
+  //inputKey->keyButton->connectSignal("key_press_event", inputKey->keyButton, key_cb);
+  inputKey->keyButton->connectSignal("button_press_event", inputKey, inputWindowEvent);
+#endif /* HAVE_GTK2 */
+  inputKey->keyBox->fill(inputKey->keyButton);
+  inputKey->keyBox->fill(inputKey->keyOLabel);
+  return inputKey->keyBox;
+}
+
+
+#ifdef HAVE_GTK2
+gint inputWindowEvent(GtkWidget* w, GdkEventKey* event, void* inputKey)
+{
+  GuiKeys::inputButton->setTitle("press a Key");
+  GuiKeys::keySignal = GuiKeys::inputButton->connectSignal("key_press_event", inputKey, key_cb);
+  GuiKeys::inputWindow->open();
 }
   
@@ -164,93 +262,164 @@
    \returns Nothing
 */
-gint Player::key_cb(GtkWidget* w, GdkEventKey* event, void* inputKey)
+gint key_cb(GtkWidget* w, GdkEventKey* event, void* inputKey)
 {
   InputKey* inputkey =(InputKey*) inputKey;
-  char title [20];
-
-  switch(event->keyval) 
+  char title [50];
+
+  switch(event->keyval)
     {
     case GDK_Up:
-      strcpy(title, "up");
+      strcpy(title, "UP");
       break;
     case GDK_Down:
-      strcpy(title, "down");
+      strcpy(title, "DOWN");
       break;
     case GDK_Left:
-      strcpy(title, "left");
+      strcpy(title, "LEFT");
       break;
     case GDK_Right:
-      strcpy(title, "right");
+      strcpy(title, "RIGHT");
       break;
       
     case GDK_space:
-      strcpy(title, "space");
-      break;
-      
-    case 65293:
-      strcpy(title, "enter");
+      strcpy(title, "SPACE");
+      break;
+      
+    case GDK_Return:
+      strcpy(title, "RETURN");
       break;
       
       // Special Keys //
+    case GDK_BackSpace:
+      strcpy(title, "BACKSPACE");
+      break;
+    case GDK_Scroll_Lock:
+      strcpy(title, "SCROLLOCK");
+      break;
+    case GDK_minus:
+      strcpy(title, "MINUS");
+      break;
+    case GDK_plus:
+      strcpy(title, "PLUS");
+      break;
+    case GDK_slash:
+      strcpy(title, "SLASH");
+      break;
+    case GDK_period:
+      strcpy(title, "PERIOD");
+      break;
+    case GDK_comma:
+      strcpy(title, "COMMA");
+      break;
+    case GDK_colon:
+      strcpy(title, "COLON");
+      break;
+    case GDK_semicolon:
+      strcpy(title, "SEMICOLON");
+      break;
+    case GDK_less:
+      strcpy(title, "LESS");
+      break;
+    case GDK_equal:
+      strcpy(title, "EQUALS");
+      break;
+    case GDK_greater:
+      strcpy(title, "GREATER");
+      break;
+    case GDK_question:
+      strcpy(title, "QUESTION");
+      break;
+    case GDK_at:
+      strcpy(title, "AT");
+      break;
+    case GDK_bracketleft:
+      strcpy(title, "LEFTBRACKET");
+      break;
+    case GDK_bracketright:
+      strcpy(title, "RIGHTBRACKET");
+      break;
+    case GDK_backslash:
+      strcpy(title, "BACKSLASH");
+      break;
+    case GDK_underscore:
+      strcpy(title, "UNDERSCORE");
+      break;
+    case GDK_quoteleft:
+      strcpy(title, "BACKQUOTE");
+      break;
+
+    case GDK_Page_Up:
+      strcpy(title, "PAGEUP");
+      break;
+    case GDK_Page_Down:
+      strcpy(title, "PAGEDOWN");
+      break;
+    case GDK_Home:
+      strcpy(title, "HOME");
+      break;
+    case GDK_Insert:
+      strcpy(title, "INSERT");
+      break;
+      
     case GDK_Escape:
-      strcpy(title, "esc");
+      strcpy(title, "ESCAPE");
       break;
     case GDK_Tab:
-      strcpy(title, "tab");
+      strcpy(title, "TAB");
       break;
     case GDK_Shift_L:
-      strcpy(title, "l_shift");
+      strcpy(title, "LSHIFT");
       break;
     case GDK_Shift_R:
-      strcpy(title, "r_shift");
+      strcpy(title, "R_SHIFT");
       break;
     case GDK_Control_L:
-      strcpy(title, "l_ctrl");
+      strcpy(title, "LCTRL");
       break;
     case GDK_Control_R:
-      strcpy(title, "r_ctrl");
+      strcpy(title, "RCTRL");
       break;
     case GDK_Alt_L:
-      strcpy(title, "l_alt");
+      strcpy(title, "LALT");
       break;
     case GDK_Alt_R:
-      strcpy(title, "r_alt");
+      strcpy(title, "RALT");
       break;
       // FXX KEYS //
     case GDK_F1:
-      strcpy(title, "f1");
+      strcpy(title, "F1");
       break;
     case GDK_F2:
-      strcpy(title, "f2");
+      strcpy(title, "F2");
       break;
     case GDK_F3:
-      strcpy(title, "f3");
+      strcpy(title, "F3");
       break;
     case GDK_F4:
-      strcpy(title, "f4");
+      strcpy(title, "F4");
       break;
     case GDK_F5:
-      strcpy(title, "f5");
+      strcpy(title, "F5");
       break;
     case GDK_F6:
-      strcpy(title, "f6");
+      strcpy(title, "F6");
       break;
     case GDK_F7:
-      strcpy(title, "f7");
+      strcpy(title, "F7");
       break;
     case GDK_F8:
-      strcpy(title, "f8");
+      strcpy(title, "F8");
       break;
     case GDK_F9:
-      strcpy(title, "f9");
+      strcpy(title, "F9");
       break;
     case GDK_F10:
-      strcpy(title, "f10");
+      strcpy(title, "F10");
       break;
     case GDK_F11:
-      strcpy(title, "f11");
+      strcpy(title, "F11");
       break;
     case GDK_F12:
-      strcpy(title, "f12");
+      strcpy(title, "F12");
       break;
       
@@ -264,7 +433,7 @@
     }
 
-  inputkey->pKeyOLabel->setValue(title);
-  inputButton->disconnectSignal(keySignal);
-  inputWindow->close();
-}
-#endif /* HAVE_GTK2 */
+  inputkey->keyOLabel->setValue(title);
+  GuiKeys::inputButton->disconnectSignal(GuiKeys::keySignal);
+  GuiKeys::inputWindow->close();
+}
+#endif /* HAVE_GTK2 */
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_keys.h	(revision 4139)
@@ -15,66 +15,52 @@
 #endif /* HAVE_GTK2 */
 
-/**
-   \brief defines the Possible Player Keys
-*/
-enum KEYS {UP, DOWN, LEFT, RIGHT, SHOOT};
+//! One KeyOption has one InputKey
+struct InputKey
+{
+  Box* keyBox;           //!< One Box that holds the Keys
+  Button* keyButton;     //!< The Button for changing the Key.
+  OptionLabel* keyOLabel;//!< The Label for displaying the Key-setting.
+};
 
-class Player;
 //! Class that creates the Keys-Options.
 class GuiKeys : public GuiElement
 {
- private:
-  Frame* keysFrame;      //!< The Frame that holds the keyOptions.
-  Box* keysBox;          //!< The Frame that holds the keyOptions.
-  Player* player1;       //!< The first Player's keys.
-  Player* player2;       //!< The seconds Player's keys.
-  Button* misc;          //!< Other keyboeard options come here. \todo include some like pause, quit and so on.
-
  public:
   GuiKeys(void);
   ~GuiKeys(void);
-};
-
-//! Class to hold infos about a Player
-/**
-   \todo split into subclass and superclass ButtonConfigurator
-*/
-class Player
-{
- private:
-  Window* pKeyWindow;     //!< The Window for a new Key-setting.
-  Frame* pKeyFrame;       //!< The Frame for a new Key-setting.
-  Button* openButton;     //!< The OpenButton for this key-settings.
-  Button* closeButton;    //!< The CloseButton for this key-settings.
-  Box* pKeysBox;          //!< The Box that holds the Key-settings.
-  
-  //! One KeyOption has one InputKey
-  struct InputKey
-  {
-    Box* pKeyBox;           //!< One Box that holds the Keys
-    Button* pKeyButton;     //!< The Button for changing the Key.
-    OptionLabel* pKeyOLabel;//!< The Label for displaying the Key-setting.
-  };
-
-  InputKey* inputKey[10];     //!< Buttons-array. \todo make it dynamic.
 
   static Window* inputWindow; //!< A Window that gets keyboard clicks. Static, because only one needed.
   static Button* inputButton; //!< A Button that gets keyboard clicks. Static, because only one needed.
   static long keySignal;      //!< A keySignal that handles keyboard clicks. Static, because only one needed.
+};
+
+//! Class to hold infos about a Player
+class PlayerKeys
+{
+ private:
+  Button* openButton;     //!< The OpenButton for this key-settings.
+
  public:
-  Player(char* player);
-
-  Widget* addKey(KEYS key, char* name);
+  PlayerKeys(char* player);
 
   Button* getOpenButton(void);
-
-#ifdef HAVE_GTK2
-  static gint inputWindowEvent(GtkWidget* w, GdkEventKey* event, void* widget);
-  static gint key_cb(GtkWidget* w, GdkEventKey* event, void* inputKey);
-#endif /* HAVE_GTK2 */
-  void setkey(KEYS key);
-  
 };
 
+class MiscKeys
+{
+ private:
+  Button* openButton;     //!< The OpenButton for this key-settings.
+
+ public:
+  MiscKeys();
+
+  Button* getOpenButton(void);  
+};
+
+Widget* addKey(const char* name, const char* defaultValue = NULL);
+#ifdef HAVE_GTK2
+gint inputWindowEvent(GtkWidget* w, GdkEventKey* event, void* widget);
+gint key_cb(GtkWidget* w, GdkEventKey* event, void* inputKey);
+#endif /* HAVE_GTK2 */
 
 
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.cc
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.cc	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.cc	(revision 4139)
@@ -37,4 +37,9 @@
 GuiUpdate::GuiUpdate(void)
 {
+  FileDialog* dataDirDialog;   //!< A FileDialog for the selection of the DataRepos
+  Button* dataDirButton;       //!< A Button for the selection of the DataRepos
+  OptionLabel* dataDirLabel;   //!< A Label fot the selection of the DataRepos
+  
+
   this->tmpDir = NULL;
   this->homeDir = NULL;
@@ -45,13 +50,34 @@
 
   this->updateFrame = new Frame("Update-Options:");
-  this->updateFrame->setGroupName("update");
+  this->updateFrame->setGroupName(CONFIG_SECTION_DATA);
   this->updateBox = new Box('v');
+
+  dataDirButton = new Button(CONFIG_NAME_DATADIR);
+  dataDirLabel = new OptionLabel(CONFIG_NAME_DATADIR, "unknown");
+  dataDirLabel->setFlagName("data-dir", "d", 0);
+  dataDirLabel->setDescription("Sets the location of the orxonox' Data-Directory");
+  dataDirLabel->saveability();
+  dataDirDialog = new FileDialog("data-Repos-location");
+  dataDirDialog->setDefaultFileName("data");
+  dataDirDialog->setMask(DATA_IDENTIFIER);
+  this->checkDataDir("../data/" DATA_IDENTIFIER, dataDirLabel);
+  dataDirDialog->disableFileOpts();
+  dataDirDialog->setOpenUpButton(dataDirButton);
+  //dataDirDialog->setChangeOption(dataDirLabel);
+  dataDirDialog->setOKFunc(dataDirLabel, GuiUpdate::checkDataDir);
+  updateBox->fill(dataDirButton);
+  updateBox->fill(dataDirLabel);
+
 #ifdef HAVE_CURL
 
   // the Button for autoUpdating
-  this->autoUpdate = new CheckButton("auto update");
+  this->autoUpdate = new CheckButton(CONFIG_NAME_AUTO_UPDATE);
   this->updateBox->fill(this->autoUpdate);
   this->autoUpdate->setFlagName("update", "u", 0);
+  this->autoUpdate->setDescription("Updates orxonox", "When this option is selected orxonox automatically searches for updates, and if found installs them");
   this->autoUpdate->saveability();
+
+  
+
 
   this->updateSourceWindowCreate();
@@ -62,9 +88,11 @@
 
 #else /* HAVE_CURL */
-  Label* noCurlLabel = new Label("since you do not have cURL,\nthis option is not availible");
+  Label* noCurlLabel = new Label("since you do not have cURL-support,\nupdate options are not availible");
   this->updateBox->fill(noCurlLabel);  
 #endif /* HAVE_CURL */
   this->updateFrame->fill(this->updateBox);
   this->setMainWidget(this->updateFrame);
+
+
 }
 
@@ -76,4 +104,24 @@
 
 }
+
+/**
+   \brief checks if the Folder containing selected File is data.oxd, and if so sets it.
+   \param 
+*/
+bool GuiUpdate::checkDataDir(const char* fileName, void* object)
+{
+  if (!strcmp(fileName+(strlen(fileName)-strlen(DATA_IDENTIFIER)), DATA_IDENTIFIER))
+    {
+      char* tmpName = new char[strlen(fileName)-strlen(DATA_IDENTIFIER)+1];
+      strncpy(tmpName, fileName, strlen(fileName)-strlen(DATA_IDENTIFIER));
+      tmpName[strlen(fileName)-strlen(DATA_IDENTIFIER)] = '\0'; 
+      static_cast<OptionLabel*>(object)->setValue(tmpName);
+      delete tmpName;
+      return true;
+    }
+  else
+    return false;
+}
+
 
 /** 
@@ -82,9 +130,9 @@
 bool GuiUpdate::getSystemInfo(void)
 {
-  PRINTF(3)("Grabbing system information\n");
+  PRINTF(5)("Grabbing system information\n");
   this->tmpDir = getenv("TMPDIR");
   if(!tmpDir)
     this->tmpDir = "/tmp";
-  PRINTF(4)("Temporary directory is: %s\n", this->tmpDir);
+  PRINTF(5)("Temporary directory is: %s\n", this->tmpDir);
 
 #ifdef __WIN32__
@@ -93,14 +141,15 @@
   this->homeDir = getenv("HOME");
 #endif
-  PRINTF(4)("Home directory is %s\n", homeDir);
-
-  this->installDataDir = "/usr/share/games/orxonox";
-  PRINTF(4)("Installation of orxonox-data will go to this directory: %s\n", this->installDataDir);
+  PRINTF(5)("Home directory is %s\n", homeDir);
+
+
+  this->installDataDir = DEFAULT_DATA_DIR;
+  PRINTF(5)("Installation of orxonox-data will go to this directory: %s\n", this->installDataDir);
 
   this->installSourceDir = "/usr/games/bin";
-  PRINTF(4)("Installation of orxonox-source will go to this directory: %s\n", this->installSourceDir);
+  PRINTF(5)("Installation of orxonox-source will go to this directory: %s\n", this->installSourceDir);
 
   this->userName = getenv("USER");
-  PRINTF(4)("Logged in username is: %s\n", this->userName);
+  PRINTF(5)("Logged in username is: %s\n", this->userName);
 }
 
@@ -108,5 +157,5 @@
 bool* GuiUpdate::checkForUpdates(void)
 {
-  PRINTF(3)("checking for new version of orxonox\n");
+  PRINTF(4)("checking for new version of orxonox\n");
   FileInfo updateFileInfo;
   updateFileInfo.fileName = "update_info";
@@ -218,5 +267,5 @@
   dataInfo->webRoot  = "http://www.orxonox.ethz.ch/files/";
   dataInfo->localRoot = "./";
-  PRINTF(3)("Preparing to download file %s.\n", dataInfo->fileName);
+  PRINTF(4)("Preparing to download file %s.\n", dataInfo->fileName);
   downloadWithStyle(dataInfo);
 }
@@ -284,9 +333,9 @@
 CURL* GuiUpdate::curlHandle = NULL;
 
-/**
-   \brief A bool parameter that shows if we are downloading.
-*/
+//! A bool parameter that shows if we are downloading.
 bool GuiUpdate::isDownloading = false;
 
+//! A parameter to see, if downloading has been canceled
+bool GuiUpdate::downloadCanceled = false;
 
 /**
@@ -303,5 +352,5 @@
       return false;
     }
-  PRINTF(3)("Downloading.\n");
+  PRINTF(4)("Downloading.\n");
   FileInfo* info =(FileInfo*)fileInfo;
   CURLcode res;
@@ -351,5 +400,5 @@
       return false;
     }
-  PRINTF(3)("Downloading.\n");
+  PRINTF(4)("Downloading.\n");
   FileInfo* info =(FileInfo*)fileInfo;
   CURLcode res;
@@ -419,5 +468,5 @@
     curl_easy_cleanup(curlHandle);
  
-  PRINTF(3)("Closing the downloaded file.\n");
+  PRINTF(4)("Closing the downloaded file.\n");
   fclose(info->fileHandle);
 
@@ -445,5 +494,5 @@
 gint GuiUpdate::cancelDownload(GtkWidget* w, GdkEventKey* event, void* bar)
 {
-  PRINTF(4)("Cannot cancle the Downloading process until after this File\n");
+  PRINTF(3)("Cannot cancle the Downloading process until after this File\n");
 }
 #endif /* HAVE_GTK2 */
Index: /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.h
===================================================================
--- /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.h	(revision 4138)
+++ /orxonox/branches/md2_loader/src/lib/gui/gui/gui_update.h	(revision 4139)
@@ -10,4 +10,7 @@
 #include "gui_element.h"
 #include "gui_gtk.h"
+
+
+#define DATA_IDENTIFIER "data.oxd"
 
 #include <stdio.h>
@@ -59,4 +62,6 @@
   static gint updateSourceFunc(GtkWidget* w, GdkEventKey* event, void* info);
 #endif /* HAVE_GTK2 */
+
+  static bool checkDataDir(const char* fileName, void* object);
 
 #ifdef HAVE_CURL
